Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter O : nat.
Parameter S : nat -> nat.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S O) case_O.
Definition eq_match_nat_type_O : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S O) case_O := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S O)) (case_O)) ((((axiom_match_nat_type_O) (return_type)) (case_O)) (case_S)).
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition sym_eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (case_S n) (match_nat_type (return_type) case_O case_S (S n)) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((leibniz.sym_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Definition not_zero : nat -> Prop := fun (n:nat) => match_nat_type (Prop) connectives.False (fun (p:nat) => connectives.True) n.
Definition not_eq_O_S : forall (n:nat), connectives.Not (logic.eq (nat) O (S n)) := fun (n:nat) => ((connectives.nmk) (logic.eq (nat) O (S n))) (fun (eqOS:logic.eq (nat) O (S n)) => ((((((eq_match_nat_type_O) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (fun (y:Prop) => y)) (((((((logic.eq_ind_r) (nat)) (S n)) (fun (x:nat) => not_zero x)) (((((((sym_eq_match_nat_type_S) (Prop)) (connectives.False)) (fun (p:nat) => connectives.True)) (n)) (fun (y:Prop) => y)) (connectives.I))) (O)) (eqOS)))).
